import { WsException } from '@nestjs/websockets';
import { PluginsService } from '../plugins/plugins.service';
import { StatusService } from './status.service';
export declare class StatusGateway {
    private statusService;
    private pluginsService;
    constructor(statusService: StatusService, pluginsService: PluginsService);
    getDashboardLayout(): Promise<any>;
    setDashboardLayout(client: any, payload: any): Promise<WsException | {
        status: string;
    }>;
    homebridgeVersionCheck(): Promise<WsException | import("../plugins/types").HomebridgePlugin>;
    homebridgeUiVersionCheck(): Promise<WsException | (import("../plugins/types").HomebridgePlugin & {
        readyForV5: {
            node: boolean;
            pnpm: boolean;
            arch: boolean;
            service: boolean;
        };
    })>;
    npmVersionCheck(): Promise<WsException | import("../plugins/types").HomebridgePlugin>;
    nodeJsVersionCheck(): Promise<unknown>;
    getOutOfDatePlugins(): Promise<WsException | import("../plugins/types").HomebridgePlugin[]>;
    getHomebridgeServerInfo(): Promise<WsException | {
        serviceUser: string;
        homebridgeConfigJsonPath: string;
        homebridgeStoragePath: string;
        homebridgeInsecureMode: boolean;
        homebridgeCustomPluginPath: string;
        homebridgePluginPath: string;
        homebridgeRunningInDocker: boolean;
        homebridgeRunningInSynologyPackage: boolean;
        homebridgeRunningInPackageMode: boolean;
        homebridgeServiceMode: boolean;
        nodeVersion: string;
        os: import("systeminformation").Systeminformation.OsData;
        glibcVersion: string;
        time: import("systeminformation").Systeminformation.TimeData;
        network: {};
    }>;
    getServerCpuInfo(): Promise<WsException | {
        cpuTemperature: {
            main: number;
            cores: any[];
            max: number;
        };
        currentLoad: number;
        cpuLoadHistory: number[];
    }>;
    getServerMemoryInfo(): Promise<WsException | {
        mem: import("systeminformation").Systeminformation.MemData;
        memoryUsageHistory: number[];
    }>;
    getServerNetworkInfo(client: any, payload?: {
        netInterfaces: string[];
    }): Promise<WsException | {
        net: import("systeminformation").Systeminformation.NetworkStatsData;
        point: number;
    }>;
    getServerUptimeInfo(): Promise<WsException | {
        time: import("systeminformation").Systeminformation.TimeData;
        processUptime: number;
    }>;
    getHomebridgePairingPin(): Promise<WsException | {
        pin: string;
        setupUri: string;
        paired: boolean;
    }>;
    getHomebridgeStatus(): Promise<WsException | {
        status: import("./status.service").HomebridgeStatus;
        consolePort: number;
        name: string;
        port: number;
        pin: string;
        setupUri: string;
        packageVersion: any;
        paired: boolean;
    }>;
    serverStatus(client: any): Promise<void>;
    getRaspberryPiThrottledStatus(): Promise<{}>;
}
